%<CustomTools>
%      <Menu>
%       <Submenu name="XT_RMD">
%        <Item name="XT_RMD_ColorMapImaris" icon="Matlab">
%          <Command>MatlabXT::XT_RMD_ColorMapImaris(%i)</Command>
%        </Item>
%       </Submenu>
%      </Menu>
%      <SurpassTab>
%        <SurpassComponent name="bpSurfaces">
%          <Item name="XT_RMD_ColorMapImaris" icon="Matlab">
%            <Command>MatlabXT::XT_RMD_ColorMapImaris(%i)</Command>
%          </Item>
%        </SurpassComponent>
%      </SurpassTab>
%    </CustomTools>

function XT_RMD_ColorMapImaris(aImarisApplicationID)

% get the application object
if isa(aImarisApplicationID, 'Imaris.IApplicationPrxHelper')
    % called from workspace
    vImarisApplication = aImarisApplicationID;
else
    % connect to Imaris interface
    javaaddpath ImarisLib.jar
    vImarisLib = ImarisLib;
    if ischar(aImarisApplicationID)
        aImarisApplicationID = round(str2double(aImarisApplicationID));
    end
    vImarisApplication = vImarisLib.GetApplication(aImarisApplicationID);
end

aIndexC = inputdlg('Input the Channel index  for colormap');
iIndexC = str2num(aIndexC{1});

aGamma = vImarisApplication.GetDataSet.GetChannelGamma(iIndexC);
aMax = vImarisApplication.GetDataSet.GetChannelRangeMax(iIndexC);
aMin = vImarisApplication.GetDataSet.GetChannelRangeMin(iIndexC);
aColorTable = vImarisApplication.GetDataSet.GetChannelColorTable(iIndexC);
vRGBA = double(aColorTable.mColorRGB);
vRed = mod(vRGBA, 256);
vRGBA = floor(vRGBA / 256);
vGreen = mod(vRGBA, 256);
vRGBA = floor(vRGBA / 256);
vBlue = mod(vRGBA, 256);
vRGBA = floor(vRGBA / 256);
aColorMap = double([vRed,vGreen,vBlue])/255;

CropColorBar = inputdlg('Input the [CropColorBar1,CropColorBar2]');
iCropColorBar = eval(CropColorBar{1});

aTickNum = inputdlg('Input the number of ticks. If customized later, input 0');
iTickNum = aTickNum{1};

if ~isequal(iTickNum,'0')
    iTickNum = eval(aTickNum{1});
    RMD_ColorMap([aMin,aMax],aGamma,iCropColorBar,iTickNum,[],aColorMap);
else
    aTicks = inputdlg('Input the[tick1,tick2,...]');
    iTicks = eval(aTicks{1});
    RMD_ColorMap([aMin,aMax],aGamma,iCropColorBar,[],iTicks,aColorMap);
end
end
